#!/bin/bash

rm -f $1

echo "\\begin{center}" >> $1

echo "\\tablefirsthead{" >> $1
echo "\\hline" >> $1
echo "\\multirow{2}{*}{p} & A & B & \multirow{2}{*}{\$\\frac{B}{A}\$}\\\\" >> $1
echo "& \$time_p(s.d)\$ & \$time_{\\lsem spec\\rsem(p.s)}(d)\$ &\\\\" >> $1
echo "\\hline" >> $1
echo "}" >> $1

echo "\\tablehead{" >> $1
echo "\\hline" >> $1
echo "\\multicolumn{4}{|l|}{\\small \\sl continued from last page}\\\\" >> $1
echo "\\hline" >> $1
echo "\\multirow{2}{*}{p} & A & B & \multirow{2}{*}{\$\\frac{B}{A}\$}\\\\" >> $1
echo "& \$time_p(s.d)\$ & \$time_{\\lsem spec\\rsem(p.s)}(d)\$ &\\\\" >> $1
echo "\\hline" >> $1
echo "}" >> $1

echo "\\tabletail{" >> $1
echo "\\hline" >> $1
echo "\\multicolumn{4}{|r|}{\\small\\sl continued on next page}\\\\" >> $1 
echo "\\hline" >> $1
echo "}" >> $1

echo "\\tablelasttail{\\hline}" >> $1

echo "\\bottomcaption{Specializing test suite Set 2 programs}" >> $1
echo "\\begin{supertabular}{|c|c|c|c|}" >> $1

PROG=lpa-progs/interpreter.lpa

for i in `ls tests/Set2/*.lpa`;
do
    echo "\\hline" >> $1
    NAME=`echo $i | cut -f 1 -d "." | cut -f 3 -d "/"`
    NAME_OUT=`echo $NAME | sed -e "s/_/\\\\\\\\_/g"`
    LP_PROG=tests/lpint/$NAME.lp
    LP_INPUT=tests/lpint/$NAME.input
    OUTPUT=`./bin/lpint -O $LP_PROG < $LP_INPUT`
    TIME=`echo $OUTPUT | cut -f 4 -d " "`

    DYNAMIC=tests/spec/$NAME.input
    RESIDUAL=tests/spec/$NAME.lp

    OUTPUT1=`./bin/lpint -O $RESIDUAL < $DYNAMIC`
    TIME1=`echo $OUTPUT1 | cut -f 4 -d " "`

    echo "$NAME_OUT & $TIME & $TIME1 & `echo "scale=3;$TIME1.0/$TIME" | bc`\\\\" >> $1;
done

echo "\\end{supertabular}" >> $1
echo "\\label{tab:result1}" >> $1
echo "\\end{center}" >> $1
