#!/bin/bash

PROG=lpa-progs/interpreter.lpa
STATIC=$1.lps
DYNAMIC=$1.lpd
EXPECTED=$1.expected
RESIDUAL=$1.residual

./bin/spec $PROG $RESIDUAL < $STATIC
OUTPUT=`./bin/lpint $RESIDUAL < $DYNAMIC`
RESULT=`echo $OUTPUT | cut -f 2 -d " "`
TIME=`echo $OUTPUT | cut -f 4 -d " "`
EXPECTED=`cat $EXPECTED | tr '\n' ' ' | sed -e "s/\ //g"`

if [ "x$RESULT" == "x$EXPECTED" ];
then RESULT_OK="OK"; 
else RESULT_OK="Failed";
fi

printf "  %-40s%10s   %s\n" $1 $TIME "$RESULT_OK"
if [ "x$RESULT" != "x$EXPECTED" ];
then echo "        result = $RESULT"; echo "        expected = $EXPECTED"
fi
