RAPPORT_DIR:=rapport

RAPPORT_FILES:=$(RAPPORT_DIR)/rapport.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/preface.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/intro.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/syntax.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/semantics.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/selfInterpreter.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/2syntax.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/2semantics.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/specialization.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/normal.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/prune.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/results.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/inference.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/code.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/testsuite.tex

RAPPORT_FILES+=$(RAPPORT_DIR)/interpreter.lp
RAPPORT_FILES+=$(RAPPORT_DIR)/append.lp

RAPPORT_FILES+=$(RAPPORT_DIR)/prog_table.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/results_table.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/spec-int2_table.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/result_piio1.tex
RAPPORT_FILES+=$(RAPPORT_DIR)/result_piio2.tex

PDFS:=${RAPPORT_DIR}/arbejdsbeskrivelse.pdf
PDFS+=${RAPPORT_DIR}/rapport.pdf

${RAPPORT_DIR}/rapport.pdf: $(RAPPORT_FILES)
	cd ${RAPPORT_DIR} && pdflatex rapport
	cd ${RAPPORT_DIR} && bibtex rapport
	cd ${RAPPORT_DIR} && pdflatex rapport
	cd ${RAPPORT_DIR} && pdflatex rapport
	cd ${RAPPORT_DIR} && pdflatex rapport

${RAPPORT_DIR}/arbejdsbeskrivelse.pdf:
	pdflatex -output-directory ${RAPPORT_DIR} arbejdsbeskrivelse.tex

pdf:$(PDFS)

$(RAPPORT_DIR)/results_table.tex: $(BIN_DIR)/gen-result.sh $(LPINT) $(SPEC_INT_PROGS) $(SPEC_INT_INPUT)
	@echo "Generating $@"
	@$(BIN_DIR)/gen-result.sh $@

$(RAPPORT_DIR)/prog_table.tex: $(BIN_DIR)/prog-result.sh $(LPINT) $(LPINT_PROGS) $(LPINT_INPUT) $(SPEC_PROGS) $(SPEC_INPUT)
	@echo "Generating $@"
	@$(BIN_DIR)/prog-result.sh $@

$(RAPPORT_DIR)/spec-int2_table.tex: $(BIN_DIR)/spec-int2-result.sh $(LPINT) $(INTERPRETER_INPUT) $(INTERPRETER) $(SPEC_INTERPRETER2)
	@echo "Generating $@"
	@$(BIN_DIR)/spec-int2-result.sh $@

$(RAPPORT_DIR)/result_piio1.tex: $(BIN_DIR)/gen-piio1.sh $(LPINT) $(INTERPRETER_INPUT) $(INTERPRETER)
	@echo "Generating $@"
	@$(BIN_DIR)/gen-piio1.sh $@

$(RAPPORT_DIR)/result_piio2.tex: $(BIN_DIR)/gen-piio2.sh $(LPINT) $(INTERPRETER2_INPUT) $(INTERPRETER) $(INTERPRETER2)
	@echo "Generating $@"
	@$(BIN_DIR)/gen-piio2.sh $@

$(RAPPORT_DIR)/interpreter.lp: $(INTERPRETER) $(BIN_DIR)/pplp $(PPLP)
	@cat $< | $(BIN_DIR)/pplp > $@

$(RAPPORT_DIR)/append.lp: tests/Set2/append.lpa $(BIN_DIR)/pplp $(PPLP)
	@$(BIN_DIR)/lpa2lp $< | $(BIN_DIR)/pplp > $@

CLEAN_FILES+=${PDFS}
CLEAN_FILES+=${RAPPORT_DIR}/*.aux 
CLEAN_FILES+=${RAPPORT_DIR}/*.log
CLEAN_FILES+=${RAPPORT_DIR}/*.toc 
CLEAN_FILES+=${RAPPORT_DIR}/*.bbl 
CLEAN_FILES+=${RAPPORT_DIR}/*.blg 
CLEAN_FILES+=${RAPPORT_DIR}/*.rel 
CLEAN_FILES+=${RAPPORT_DIR}/*.dvi 
CLEAN_FILES+=${RAPPORT_DIR}/*.lof 
CLEAN_FILES+=${RAPPORT_DIR}/*.lot
CLEAN_FILES+=${RAPPORT_DIR}/rapport.out
CLEAN_FILES+=${RAPPORT_DIR}/*~
CLEAN_FILES+=${RAPPORT_DIR}/interpreter.lp
CLEAN_FILES+=$(RAPPORT_DIR)/prog_table.tex
CLEAN_FILES+=$(RAPPORT_DIR)/results_table.tex
CLEAN_FILES+=$(RAPPORT_DIR)/spec-int2_table.tex
CLEAN_FILES+=$(RAPPORT_DIR)/result_piio1.tex
CLEAN_FILES+=$(RAPPORT_DIR)/result_piio2.tex

.PHONY: pdf
