structure Optimizer =
struct

exception OptimizerError of string;

open Command;
open Expression;

fun if2_to_if1( ASSIGN( e ) ) =
    ASSIGN( e )
  | if2_to_if1( SEQ( c1, c2 ) ) =
    SEQ( if2_to_if1( c1 ), if2_to_if1( c2 ) )
  | if2_to_if1( LOOP( c ) ) =
    LOOP( if2_to_if1( c ) )
  | if2_to_if1( IF2( e, c1, ASSIGN( VAR ) ) ) =
    IF1( e, if2_to_if1( c1 ) )
  | if2_to_if1( IF2( e, c1, c2 ) ) =
    IF2( e, if2_to_if1( c1 ), if2_to_if1( c2 ) )
  | if2_to_if1( IF1( e, c ) ) =
    IF1( e, if2_to_if1( c ) )
  | if2_to_if1( REPEAT ) =
    REPEAT
;

fun optimize( p ) =
    let
        val new_p = p;
        val new_p = fix( if2_to_if1, new_p );
    in
        if( p = new_p )
        then new_p
        else optimize( new_p )
    end
;

end
;
 
