structure Tokens = Tokens

type pos = int
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult= (svalue,pos) token

val pos = ref 0;
val eof = fn () => Tokens.EOF( !pos, !pos );
val error = fn (e,l : int,_) =>
               TextIO.output( TextIO.stdOut,"line " ^ 
                              Int.toString( l ) ^
                               ": " ^ e ^ "\n")

%%
%header (functor LPLexFun(structure Tokens : LP_TOKENS));

alpha=[A-Za-z];
digit=[0-9];
ws = [\ \t];

%%
\n         => ( pos := (!pos) + 1; lex() );
{ws}+      => ( lex() );
#.*        => ( lex() );
"N"        => ( Tokens.NIL( !pos, !pos ) );
"X"        => ( Tokens.VAR( !pos, !pos ) );
":="       => ( Tokens.ASSIGN( !pos, !pos ) );
"hd"       => ( Tokens.HD( !pos, !pos ) );
"("        => ( Tokens.LPAR( !pos, !pos ) );
")"        => ( Tokens.RPAR( !pos, !pos ) );
";"        => ( Tokens.SEQ( !pos, !pos ) );
"{"        => ( Tokens.LBRACE( !pos, !pos ) );
"}"        => ( Tokens.RBRACE( !pos, !pos ) );
","        => ( Tokens.COMMA( !pos, !pos ) );
"tl"       => ( Tokens.TL( !pos, !pos ) );
"=?"       => ( Tokens.EQ( !pos, !pos ) );
"cons"     => ( Tokens.CONS( !pos, !pos ) );
"repeat"   => ( Tokens.REPEAT( !pos, !pos ) );
"if1"      => ( Tokens.IF1( !pos, !pos ) );
"if2"      => ( Tokens.IF2( !pos, !pos ) );
"loop"     => ( Tokens.LOOP( !pos, !pos ) );
"then"     => ( Tokens.THEN( !pos, !pos ) );
"else"     => ( Tokens.ELSE( !pos, !pos ) );
"."        => ( error ("ignoring bad character "^yytext,!pos,!pos);
                lex());
