structure LPAparser =
struct

structure LPALrVals =
  LPALrValsFun(structure Token = LrParser.Token)
structure LPALex = 
  LPALexFun(structure Tokens = LPALrVals.Tokens)
structure LPAParser=
  Join( structure ParserData = LPALrVals.ParserData
        structure Lex=LPALex
        structure LrParser=LrParser)

fun invoke lexstream =
    let
        fun print_error (s,i:int,_) =
            TextIO.output(TextIO.stdOut,
                          "Error, line " ^ (Int.toString i) ^ ", " ^ s ^ "\n")
        val result = LPAParser.parse( 0, lexstream, print_error, () );
     in
        result
    end

fun parseFile( file ) = 
    let
        val instream = TextIO.openIn( file );
        val lexer = LPAParser.makeLexer( fn _ => ( case TextIO.inputLine instream of SOME( s ) => s | NONE => "" ) )
        val dummyEOF = LPALrVals.Tokens.EOF(0,0)
        fun loop lexer =
            let 
                val (result,lexer) = invoke lexer
                val (nextToken,lexer) = LPAParser.Stream.get lexer
             in 
                if LPAParser.sameToken(nextToken,dummyEOF) 
                then result
                else loop lexer
            end
     in
        loop lexer
    end
;

end
;
