structure AbstractValue =
struct

open Value;

exception AbstractValueException of string;

datatype AbstractValue =
         AD
       | AV of Value
       | AHD of AbstractValue
       | ATL of AbstractValue
       | ACONS of AbstractValue * AbstractValue
       | AEQ of AbstractValue * AbstractValue
;

fun isValue( AV v ) = true
  | isValue( av ) = false
;

fun value( AV v ) = 
    v
  | value( av ) = 
    raise AbstractValueException( "abstract value" ^
                                  " is not a value" )
;

fun toString( AD ) = "D"
  | toString( AV v ) = Value.toString( v )
  | toString( AHD e ) = "hd( " ^ toString( e ) ^ ")"
  | toString( ATL e ) = "tl( " ^ toString( e ) ^ ")"
  | toString( ACONS( e1, e2 ) ) = 
    "(" ^ toString( e1 ) ^ "." ^ toString( e2 ) ^ ")"
  | toString( AEQ( e1, e2 ) ) = 
    "=?( " ^ toString( e1 ) ^ "." ^ toString( e2 ) ^ ")"
;

end
;
