structure Value =
struct

open Tools;

datatype Value =
         N
       | C of Value * Value
;

fun toString( N ) = 
    "N"
  | toString( C( v1, v2 ) ) = 
    "(" ^ toString( v1 ) ^ "," ^ toString( v2 ) ^ ")"
;

fun toStringPP( C(v1, v2), max, n ) = 
    let
        val s1 = toString( v1 );
        val s2 = toString( v2 );
        val totalSize = n + 3 +
                        String.size( s1 ) + 
                        String.size( s2 );
    in
        if( totalSize > max )
        then "<" ^ s1 ^ ".\n" ^ indentToString( n + 1 )
             ^ toStringPP( v2, max, n + 1 ) ^ ">"
        else "<" ^ s1 ^ "." ^ s2 ^ ">"
    end
  | toStringPP( N, max, n ) = "N"
;

end
;
