structure Tokens = Tokens

type pos = int
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult= (svalue,pos) token

val pos = ref 0;
val eof = fn () => Tokens.EOF( !pos, !pos );
val error = fn (e,l : int,_) =>
               TextIO.output( TextIO.stdOut,"line " ^ 
                              Int.toString( l ) ^
                               ": " ^ e ^ "\n")

%%
%header (functor ValueLexFun(structure Tokens : Value_TOKENS));

ws = [\ \t];
%%
\n         => ( pos := (!pos) + 1; lex() );
{ws}+      => ( lex() );
"N"        => ( Tokens.NIL( !pos, !pos ) );
"("        => ( Tokens.LPAR( !pos, !pos ) );
")"        => ( Tokens.RPAR( !pos, !pos ) );
","        => ( Tokens.COMMA( !pos, !pos ) );

"."        => ( error ("ignoring bad character "^yytext,!pos,!pos);
                lex());
