structure ValueParser =
struct

structure ValueLrVals =
  ValueLrValsFun(structure Token = LrParser.Token)
structure ValueLex = 
  ValueLexFun(structure Tokens = ValueLrVals.Tokens)
structure ValueParser=
  Join( structure ParserData = ValueLrVals.ParserData
        structure Lex=ValueLex
        structure LrParser=LrParser)

fun invoke lexstream =
    let
        fun print_error (s,i:int,_) =
            TextIO.output(TextIO.stdOut,
                          "Error, line " ^ (Int.toString i) ^ ", " ^ s ^ "\n")
        val result = ValueParser.parse( 0, lexstream, print_error, () );
     in
        result
    end

fun stringParse ( str ) = 
    let
        val instream = TextIO.openString( str );
        val lexer = ValueParser.makeLexer( fn _ => ( case TextIO.inputLine instream of SOME( s ) => s | NONE => "" ) )
        val dummyEOF = ValueLrVals.Tokens.EOF(0,0)
        fun loop lexer =
            let 
                val (result,lexer) = invoke lexer
                val (nextToken,lexer) = ValueParser.Stream.get lexer
             in 
                if ValueParser.sameToken(nextToken,dummyEOF) 
                then result
                else loop lexer
            end
     in
        loop lexer
    end
;

fun parse() = 
    let
        val lexer = ValueParser.makeLexer( fn _ => ( case TextIO.inputLine TextIO.stdIn of SOME( s ) => s | NONE => "" ) )
        val dummyEOF = ValueLrVals.Tokens.EOF(0,0)
        fun loop lexer =
            let 
                val (result,lexer) = invoke lexer
                val (nextToken,lexer) = ValueParser.Stream.get lexer
             in 
                if ValueParser.sameToken(nextToken,dummyEOF) 
                then result
                else loop lexer
            end
     in
        loop lexer
    end
;
end
;
