ALL_SRC:=$(shell find $(SRC_DIR) . -name "*.sml" | grep -v ".cm" )

LPINT:=$(BIN_DIR)/lpint-image.ppc-darwin
LP2D:=$(BIN_DIR)/lp2d-image.ppc-darwin
SPEC:=$(BIN_DIR)/spec-image.ppc-darwin
LPA2LP:=$(BIN_DIR)/lpa2lp-image.ppc-darwin
PPLP:=$(BIN_DIR)/pplp-image.ppc-darwin

PROGS:=$(LPINT) $(LP2D) $(SPEC) $(LPA2LP) $(PPLP)

$(LPINT): $(ALL_SRC)
	@echo "Building $@"
	@ml-build ${SRC_DIR}/lpint/lpint.cm Main.main $@

$(LP2D): $(ALL_SRC)
	@echo "Building $@"
	@ml-build ${SRC_DIR}/lp2d/lp2d.cm Main.main $@

$(SPEC): $(ALL_SRC)
	@echo "Building $@"
	@ml-build ${SRC_DIR}/spec/spec.cm Main.main $@

$(LPA2LP): $(ALL_SRC)
	@echo "Building $@"
	@ml-build ${SRC_DIR}/lpa2lp/lpa2lp.cm Main.main $@

$(PPLP): $(ALL_SRC)
	@echo "Building $@"
	@ml-build ${SRC_DIR}/pplp/pplp.cm Main.main $@

CLEAN_FILES+=$(shell find . -name ".cm" )
CLEAN_FILES+=${BIN_DIR}/*.ppc-darwin
CLEAN_FILES+=${SRC_DIR}/lpint/LP.grm.*
CLEAN_FILES+=${SRC_DIR}/lpint/LP.lex.*
CLEAN_FILES+=${SRC_DIR}/lpm2lp/LPM.grm.*
CLEAN_FILES+=${SRC_DIR}/lpm2lp/LPM.lex.*
