structure Main =
struct

open LPparser;
open ValueParser;
open Interpreter;

fun pplpUsage() =
    let
        val _ = print( "pplp <landscape>\n" );
        val _ = print( "  expectes input on stdin and output on stdout\n" );
    in
        1
    end
;

fun pplpRun( width ) =
    let
        val prog_ast = LPparser.parse();

        val _ = print( Command.toStringPP( prog_ast, width, 0 ) ^ "\n" );
    in
        0
    end
;

fun main( cmdline, arg ) =
    if length( arg ) = 0
    then pplpRun( 60 )
    else if length( arg ) = 1
    then pplpRun( 100 )
    else pplpUsage()
         handle ValueException( msg ) =>
                let
                    val _ = print( "Value error: " ^ msg ^ "\n" );
                in
                    1
                end
         | SyntaxException( msg ) =>
                let
                    val _ = print( "Syntax error: " ^ msg ^ "\n" );
                in
                    1
                end
         | ex =>
                let
                    val _ = print( "General exception error\n" );
                in
                    1
                end
;

end
;
