structure Main =
struct

open LPAparser;
open ValueParser;
open Specializer;

fun specUsage() =
    let
        val _ = print( "spec <input filename>" ^
                       " <output filename>\n" );
        val _ = print( "\n" );
    in
        1
    end
;

fun specRun( filename, output ) =
    let
        val prog_ast = parseFile( filename );
        val value_ast = parse();
        val residual_output = TextIO.openOut( output );
        val result = specialize( prog_ast, value_ast );
        val _ = TextIO.output( residual_output, 
                               Command.toString( result ) );
        val _ = TextIO.closeOut( residual_output );
    in
        0
    end
;

fun main( cmdline, arg ) =
    if length( arg ) <> 2
    then specUsage()
    else specRun( hd( arg ), hd( tl( arg ) ) )
         handle SpecializerError( msg ) =>
                let
                    val _ = print( "SpecializerError: " ^ 
                                   msg ^ "\n" );
                in
                    1
                end
              | AbstractValueException( msg ) =>
                let
                    val _ = print( "AbstractValueError: " ^ 
                                   msg ^ "\n" );
                in
                    1
                end
              | ex =>
                let
                    val _ = print( "Unknown exception cought\n" );
                in
                    1
                end
;

end
;
